
From: Neil Brown <neilb@cse.unsw.edu.au>

Avoid unlock-without-lock problem on error path in nfsd4_setclientid_confirm

Signed-off-by: Neil Brown <neilb@cse.unsw.edu.au>
Signed-off-by: Andrew Morton <akpm@osdl.org>
---

 25-akpm/fs/nfsd/nfs4state.c |    3 +--
 1 files changed, 1 insertion(+), 2 deletions(-)

diff -puN fs/nfsd/nfs4state.c~nfsd4_setclientid_confirm-locking-fix fs/nfsd/nfs4state.c
--- 25/fs/nfsd/nfs4state.c~nfsd4_setclientid_confirm-locking-fix	2005-01-05 20:43:09.848823144 -0800
+++ 25-akpm/fs/nfsd/nfs4state.c	2005-01-05 20:43:09.854822232 -0800
@@ -802,9 +802,8 @@ nfsd4_setclientid_confirm(struct svc_rqs
 	clientid_t * clid = &setclientid_confirm->sc_clientid;
 	int status;
 
-	status = nfserr_stale_clientid;
 	if (STALE_CLIENTID(clid))
-		goto out;
+		return nfserr_stale_clientid;
 	/* 
 	 * XXX The Duplicate Request Cache (DRC) has been checked (??)
 	 * We get here on a DRC miss.
_
